#include "prizm.h"
#include "CBP.h"


struct st_round CB_Round = { Norm , 1} ; // Round
int ENG=0;	// ENG flag

//---------------------------------------------------------------------------------------------
void CB_PrintC( int x, int y,const unsigned char *c ){
	unsigned short color,backcolor=CB_BackColorIndex;
	if ( CB_ColorIndex >= 0 ) color=CB_ColorIndex; else color=TEXT_COLOR_BLACK;
	if ( *c == 0xFF ) {
		*c++;
		if ( ( (*c)>=0xA0 ) && ( (*c)<=0xDF ) ) KPrintChar( (--x)*6, (--y)*8, *c );
		else	PrintCXY( (x-1)*3*6, (y-1)*3*8, (unsigned char*)"@" , 0, -1, color, backcolor, 1, 0 );
	} else {
		PrintCXY( (x-1)*3*6, (y-1)*3*8, c, 0, -1, color, backcolor, 1, 0 );
	}
}
void CB_PrintRevC( int x, int y,const unsigned char *c ){
	unsigned char kana[]="*";
	unsigned short color,backcolor=CB_BackColorIndex;
	if ( CB_ColorIndex >= 0 ) color=CB_ColorIndex; else color=TEXT_COLOR_BLACK;
	if ( *c == 0xFF ) {
		*c++;
		if ( ( (*c)>=0xA0 ) && ( (*c)<=0xDF ) ) KPrintRevChar( (--x)*6, (--y)*8, *c );
		else	PrintCXY( (x-1)*3*6, (y-1)*3*8, (unsigned char*)"@" , 2, -1, color, ~backcolor, 1, 0 );
	} else {
		jmp:
		PrintCXY( (x-1)*3*6, (y-1)*3*8, c, 2, -1, color, ~backcolor, 1, 0 );
	}
}
void CB_Print( int x, int y, const unsigned char *str){
	int c=(char)*str;
	while ( c ) {
		CB_PrintC( x, y, str++ );
		if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  str++;
		x++;
		if ( x>21 ) break;
		c=(char)*str;
	}
}
void CB_PrintRev( int x, int y, const unsigned char *str){
	unsigned int c=(char)*str;
	while ( c ) {
		CB_PrintRevC( x, y, str++ );
		if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  str++;
		x++;
		if ( x>21 ) break;
		c=(char)*str;
	}
}

void CB_PrintXYCx3( int px, int py,const unsigned char *c , int mode ){
	unsigned short color,backcolor=CB_BackColorIndex;
	if ( CB_ColorIndex >= 0 ) color=CB_ColorIndex; else color=TEXT_COLOR_BLACK;
	if ( *c == 0xFF ) {
		*c++;
		if ( ( (*c)>=0xA0 ) && ( (*c)<=0xDF ) ) KPrintRevChar( (px), (py), *c );
		else	PrintCXY( px*3, py*3, (unsigned char*)"@" , 0, -1, color, backcolor, 1, 0 );
	} else {
		PrintCXY( px*3, py*3, c, 0, -1, color, backcolor, 1, 0 );
	}
}
void CB_PrintXYx3( int px, int py, const unsigned char *str, int mode){
	int c=(char)*str;
	while ( c ) {
		CB_PrintXYCx3( px, py, str++ , mode);
		if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  str++;
		px+=6;
		if ( px>127 ) break;
		c=(char)*str;
	}
}
void CB_PrintXYC( int px, int py,const unsigned char *c , int mode ){
	unsigned short color,backcolor=CB_BackColorIndex;
	if ( CB_ColorIndex >= 0 ) color=CB_ColorIndex; else color=TEXT_COLOR_BLACK;
	if ( *c == 0xFF ) {
		*c++;
		if ( ( (*c)>=0xA0 ) && ( (*c)<=0xDF ) ) KPrintRevChar( (px)/3, (py)/3, *c );
		else	PrintCXY( px, py, (unsigned char*)"@" , 0, -1, color, backcolor, 1, 0 );
	} else {
		PrintCXY( px, py, c, 0, -1, color, backcolor, 1, 0 );
	}
}
void CB_PrintXY( int px, int py, const unsigned char *str, int mode){
	int c=(char)*str;
	while ( c ) {
		CB_PrintXYC( px, py, str++ , mode);
		if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  str++;
		px+=18;
		if ( px>383 ) break;
		c=(char)*str;
	}
}
void CB_PrintLocateXY( int px, int py, const unsigned char *str, int mode){
	int c=(char)*str;
	unsigned short color,backcolor=CB_BackColorIndex;
	if ( CB_ColorIndex >= 0 ) color=CB_ColorIndex; else color=CB_ColorIndexPlot;
	while ( c ) {
		PrintCXY( px, py, str++, 0, -1, color, backcolor, 1, 0 );
		if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  str++;
		px+=18;
		if ( px>383 ) break;
		c=(char)*str;
	}
}


//---------------------------------------------------------------------------------------------
int CB_PrintMinix1( int X, int Y, unsigned char*buf, int mode ) {	// {384,192} mode str
	unsigned short color,backcolor=CB_BackColorIndex;
	if ( CB_ColorIndex >= 0 ) color=CB_ColorIndex; else color=CB_ColorIndexPlot;
	return PrintMinix1( X, Y, buf, mode, color, backcolor ) ;
}

int CB_PrintMiniC( int px, int py, unsigned char *str, int mode){	// {384,192} mode char
	int k,i;
	unsigned char b;
	int c=(char)*str;
	if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  k=2; else k=1;
	b=str[k];
	str[k]='\0';
	if (c==0xFFFFFFFF) i=KPrintCharMini( px, py, str , mode );
	else	i=CB_PrintMinix1( px, py, str , mode );
	str[k]=b;
	return i;
}
int CB_PrintMini( int px, int py, const unsigned char *str, int mode){	// {384,192} mode string
	unsigned char mod,kind;
	int i;
	int c=(char)*str;
	while ( c ) {
		i=CB_PrintMiniC( px, py, str++, mode );
		if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  str++;
		px+=i;
		if ( px>383 ) break;
		c=(char)*str;
	}
}

int CB_PrintMiniC_fx( int px, int py, unsigned char *str, int mode){	// {384,192} mode string fx font
	int k,i;
	unsigned char b;
	int c=(char)*str;
	if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  k=2; else k=1;
	b=str[k];
	str[k]='\0';
	i=KPrintCharMini( px, py, str , mode );
	str[k]=b;
	return i;
}
int CB_PrintMini_fx( int px, int py, const unsigned char *str, int mode){	// {384,192} mode string fx font
	unsigned char mod,kind;
	int i;
	int c=(char)*str;
	while ( c ) {
		i=KPrintCharMini( px, py, str++ , mode );
		if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  str++;
		px+=i;
		if ( px>383 ) break;
		c=(char)*str;
	}
}

int CB_PrintMiniCx3( int px, int py, unsigned char *str, int mode){	// {128,64} mode	fx mode char
	int k,i;
	unsigned char b;
	int c=(char)*str;
	if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  k=2; else k=1;
	b=str[k];
	str[k]='\0';
	if (c==0xFFFFFFFF) i=KPrintCharMini( px*3, py*3, str , mode )/3;
	else	i=CB_PrintMinix1( px*3, py*3, str , mode )/3;
	str[k]=b;
	return i;
}
int CB_PrintMinix3( int px, int py, const unsigned char *str, int mode){	// {128,64} mode	fx mode string
	unsigned char mod,kind;
	int i;
	int c=(char)*str;
	while ( c ) {
		i=CB_PrintMiniCx3( px, py, str++, mode );
		if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  str++;
		px+=i;
		if ( px>127 ) break;
		c=(char)*str;
	}
}

int CB_PrintMiniLength( unsigned char *str ){
	int X=0,Y=0;
	int k,i;
	unsigned char b;
	int c=(char)*str;
	if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  k=2; else k=1;
	b=str[k];
	str[k]='\0';
	if ( (c==0xFFFFFFFF) ) {
		str[k]=b;
		return KPrintCharMini( 0, 0, str , 0x21 )/3;
	}
	PrintMini(&X, &Y, str, 0, 0xFFFFFFFF, 0, 0, 0xFFFF, 0x0000, 0, 0);
	str[k]=b;
	return X/3;
}

int CB_PrintMiniLengthStr( unsigned char *str ){
	int i,length=0;
	int c=(char)*str;
	while ( c ) {
		i=CB_PrintMiniLength( str++ );
		if ( (c==0x7F)||(c==0xFFFFFFF9)||(c==0xFFFFFFE5)||(c==0xFFFFFFE6)||(c==0xFFFFFFE7)||(c==0xFFFFFFFF) )  str++;
		length+=i;
		c=(char)*str;
	}
	return length;
}

//---------------------------------------------------------------------------------------------
//void PrintXYR(int x,int y,char *buffer,int rev){
// 	if ( rev ) PrintXY(x,y,(unsigned char *)buffer,1);
//		else   PrintXY(x,y,(unsigned char *)buffer,0);
//}

void Hex8PrintXY(int x, int y, char *str, unsigned int hex){
	char buffer[22];
	sprintf(buffer,"%08X",hex);
	locate(x,y); Print((unsigned char *)str); Print((unsigned char *)buffer);
}
void Hex4PrintXY(int x, int y, char *str, unsigned int hex){
	char buffer[22];
	sprintf(buffer,"%04X",hex);
	locate(x,y); Print((unsigned char *)str); Print((unsigned char *)buffer);
}
void Hex2PrintXY(int x, int y, char *str, unsigned int hex){
	char buffer[22];
	sprintf(buffer,"%02X",hex);
	locate(x,y); Print((unsigned char *)str); Print((unsigned char *)buffer);
}

int YesNo( char*buffer){
	unsigned int key;

	SaveDisp(SAVEDISP_PAGE1);
	PopUpWin(4);
	locate(3,2); Print((unsigned char *)buffer);
	locate(3,4); Print((unsigned char *) "   Yes:[F1]");
	locate(3,5); Print((unsigned char *) "   No :[F6]");
//	Bdisp_PutDisp_DD();

	KeyRecover(); 
	while ( 1 ) {
		GetKey(&key);	
		if ( key == KEY_CTRL_F1  ) break ;
		if ( key == KEY_CTRL_F6  ) break ;
		if ( key == KEY_CTRL_EXIT) break ;
		if ( key == KEY_CTRL_AC  ) break ;
		if ( key == KEY_CTRL_EXE ) break ;
	}
	RestoreDisp(SAVEDISP_PAGE1);
	if ( key == KEY_CTRL_F1  ) return 1 ; // Yes
	if ( key == KEY_CTRL_EXE ) return 1 ; // Yes
//	Bdisp_PutDisp_DD();
	return 0 ; // No
}

int YesNo2( char*buffer, char*buffer2){
	unsigned int key;

	SaveDisp(SAVEDISP_PAGE1);
	PopUpWin(5);
	locate(3,2); Print((unsigned char *)buffer);
	locate(3,3); Print((unsigned char *)buffer2);
	locate(3,5); Print((unsigned char *) "   Yes:[F1]");
	locate(3,6); Print((unsigned char *) "   No :[F6]");
//	Bdisp_PutDisp_DD();

	KeyRecover(); 
	while ( 1 ) {
		GetKey(&key);	
		if ( key == KEY_CTRL_F1  ) break ;
		if ( key == KEY_CTRL_F6  ) break ;
		if ( key == KEY_CTRL_EXIT) break ;
		if ( key == KEY_CTRL_AC  ) break ;
		if ( key == KEY_CTRL_EXE ) break ;
	}
	RestoreDisp(SAVEDISP_PAGE1);
	if ( key == KEY_CTRL_F1  ) return 1 ; // Yes
	if ( key == KEY_CTRL_EXE ) return 1 ; // Yes
//	Bdisp_PutDisp_DD();
	return 0 ; // No
}

void ErrorMSG(char*buffer,int err){
	unsigned int key;
	char buf[20];

	SaveDisp(SAVEDISP_PAGE1);
	PopUpWin(5);
	sprintf(buf,"code:%d",err);
	locate(3,2); Print((unsigned char *)buffer);
	locate(3,4); Print((unsigned char *)buf);
	locate(3,6); Print((unsigned char *) "   Press:[EXIT]");

	GetKey(&key);	
	RestoreDisp(SAVEDISP_PAGE1);
}
void ErrorMSGstr(char*buffer,char*buffer2){
	unsigned int key;
	char buf[20];

	SaveDisp(SAVEDISP_PAGE1);
	PopUpWin(5);
	locate(3,2); Print((unsigned char *)buffer);
	locate(3,4); Print((unsigned char *)buffer2);
	locate(3,6); Print((unsigned char *) "   Press:[EXIT]");

	GetKey(&key);	
	RestoreDisp(SAVEDISP_PAGE1);
}
void ErrorMSGstr1(char*buffer){
	unsigned int key;

	SaveDisp(SAVEDISP_PAGE1);
	PopUpWin(4);
	locate(3,3); Print((unsigned char *)buffer);
	locate(3,5); Print((unsigned char *) "   Press:[EXIT]");

	GetKey(&key);	
	RestoreDisp(SAVEDISP_PAGE1);
}

void ErrorADRS(char*buffer,int err){
	unsigned int key;
	char buf[20];

	SaveDisp(SAVEDISP_PAGE1);
	PopUpWin(5);
	locate(3,2); Print((unsigned char *)buffer);
	Hex8PrintXY(3,4,"addres:",err);
	locate(3,6); Print((unsigned char *) "   Press:[EXIT]");

	GetKey(&key);	
	RestoreDisp(SAVEDISP_PAGE1);
}

void MSG1(char*buffer1){
	SaveDisp(SAVEDISP_PAGE1);
	PopUpWin(1);
	locate(3,4); Print((unsigned char *)buffer1);
	Bdisp_PutDisp_DD_DrawBusy();
}
void MSG2(char*buffer1,char*buffer2){
	SaveDisp(SAVEDISP_PAGE1);
	PopUpWin(2);
	locate(3,3); Print((unsigned char *)buffer1);
	locate(3,4); Print((unsigned char *)buffer2);
	Bdisp_PutDisp_DD_DrawBusy();
}
void MSGpop(void){
//	MsgBoxPop();
	RestoreDisp(SAVEDISP_PAGE1);
	Bdisp_PutDisp_DD();
}

void PopUpWin( int n ){
//	MsgBoxPush( n );
	int y1,y2;
	int	tmp=CB_G1MorG3M;
	int tmp2=CB_ColorIndex;
	switch ( n ) {
		case 1:
			y1=2;
			y2=4;
			break;
		case 2:
			y1=1;
			y2=4;
			break;
		case 3:
			y1=1;
			y2=5;
			break;
		case 4:
			y1=0;
			y2=5;
			break;
		case 5:
			y1=0;
			y2=6;
			break;
		case 6:
			y1=0;
			y2=7;
			break;
		default:
			return;
	}
	CB_G1MorG3M=1;	// fx style
	CB_ColorIndex=0x001F;	// Blue
	ML_rectangle( 9, 8*y1+3, 116, 8*y2+3, 1, 1, 0);
	ML_line(  10, 8*y2+4, 117, 8*y2+4, 1);
	ML_line( 117, 8*y1+4, 117, 8*y2+4, 1);
	CB_G1MorG3M=tmp;
	CB_ColorIndex=tmp2;
}

//---------------------------------------------------------------------------------------------

void ProgressBarPopUp( char *buffer, char *buffer2 ) {
//		SaveDisp(SAVEDISP_PAGE1);
//		PopUpWin(5);
//		locate(3,2); Print((unsigned char *)buffer);
//		locate(3,3); Print((unsigned char *)buffer2);
//		ML_rectangle( 17, 32, 106, 40, 1, 1, 0);
}

void ProgressBar(int current, int max) {
	int i;
//	unsigned int t=RTC_GetTicks();
//	if ( abs(t-skip_count)>4 ) { skip_count=t;		// default 128/4=32  1/32s
//		GUI_ProgressBar( current, max);
//		Bdisp_PutDisp_DD();
//	}
}

//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------

char UseHiddenRAM=1;	//	0x11 :HiddenRAMInit off
char IsHiddenRAM=0;

#define PICTBACKSPACE 512	//
#define NORMALRAM_TOP 0xAC000000
#define HIDDENRAM_TOP 0x8C300000
#define HIDDENRAM_END 0x8C800000
char * HiddenRAM_Top  =(char*)HIDDENRAM_TOP+16+256;	// Hidden RAM TOP
char * HiddenRAM_End  =(char*)HIDDENRAM_END-PICTBACKSPACE;	// Hidden RAM END

char * HiddenRAM_ProgNextPtr=(char*)HIDDENRAM_TOP+16+256;	// Hidden RAM Prog next ptr
char * HiddenRAM_MatTopPtr =(char*)HIDDENRAM_END-PICTBACKSPACE;	// Hidden RAM Mat top ptr

char IsCG20;	//	1:CG10/20   0:CG50

/*
----------------------------------------
HiddenRAM_Top(0x8C200000)
		>>>
		History buffer(256byte)
		(prog area) HiddenRAM_ProgNextPtr
			... 
			(free area)
				...
				(Mat area)	HiddenRAM_MatTopPtr
				<<<
					Matrix & List data area
					<<<
					(*MatAry)
					MatAry index area
						<<<
							Pict buffer ( 1~20~99)
							<<<
								HiddenRAM_End(0x8C800000)
----------------------------------------
*/
//---------------------------------------------------------------------------------------------
void * HiddenRAM(void){	// Check HiddenRAM 
//	unsigned int *VRAM=GetVRAMAddress();
	volatile unsigned int *NorRAM=(volatile unsigned int*)NORMALRAM_TOP;	// Nomarl RAM TOP (no cache area)
	volatile unsigned int *HidRAM=(volatile unsigned int*)HIDDENRAM_TOP;	// Hidden RAM TOP (cashe area)
	int a,b;
	int K55=0x55555555;
	int KAA=0xAAAAAAAA;
	char * HidAddress=NULL;
	
	IsHiddenRAM=0;
	a= *NorRAM;
	b= *HidRAM;
	*NorRAM=K55;
	*HidRAM=KAA;
	if ( *NorRAM != *HidRAM ) {
			HidAddress=(char*)HidRAM;	// Hidden RAM Exist
			IsHiddenRAM=1;
	}
	*NorRAM=a;
	*HidRAM=b;
	return HidAddress;
}

void * HiddenRAM_mallocProg( size_t size ){
	char * ptr;
	if ( ( UseHiddenRAM ) && ( IsHiddenRAM ) ) {
		ptr = HiddenRAM_ProgNextPtr;
		HiddenRAM_ProgNextPtr += ( (size+3) & 0xFFFFFFFC );	// 4byte align
		if ( HiddenRAM_ProgNextPtr < HiddenRAM_MatTopPtr ) return ptr;
		HiddenRAM_ProgNextPtr = ptr;
		return malloc( size );
	} else {
		return malloc( size );
	}
}

void * HiddenRAM_mallocMat( size_t size ){
	char * ptr;
	if ( ( UseHiddenRAM ) && ( IsHiddenRAM ) ) {
		ptr = HiddenRAM_MatTopPtr;
		ptr -= ( (size+7) & 0xFFFFFFF8 );	// 8byte align
		if ( ptr < HiddenRAM_ProgNextPtr ) return malloc( size );
		HiddenRAM_MatTopPtr = ptr;
		return ptr;
	} else {
		return malloc( size );
	}
}

unsigned char * GetheapPict(){
	unsigned char *pict;
	if ( PictbaseCount >= PictbaseCountMAX ) {
		if ( PictbasePtr < PictbaseMAX ) {
//			Pictbase[++PictbasePtr] = (unsigned char *) malloc( VRAMSIZE_FX * PictbaseMAX +4 );
			Pictbase[++PictbasePtr] = GVRAM+0x28800;
		} else { CB_Error(NotEnoughMemoryERR); return NULL; }	// Not enough memory error
		if( Pictbase[PictbasePtr] == NULL ) { CB_Error(NotEnoughMemoryERR); return NULL; }	// Not enough memory error
		PictbaseCount=0;
	}
	pict = Pictbase[PictbasePtr] + VRAMSIZE_FX * PictbaseCount;
	PictbaseCount++;
	return pict;
}
unsigned char *  HiddenRAM_mallocPict( int pictNo ){
	char *  ptr;
	if ( ( UseHiddenRAM ) && ( IsHiddenRAM ) ) {
		ptr = HiddenRAM_End-VRAMSIZE*(pictNo);
		return (unsigned char *)ptr;
	} else {
		return GetheapPict();
	}
}

void HiddenRAM_freeProg( void *ptr ){
	if ( (int)ptr < (int)HiddenRAM_Top ) free( ptr );
	else 
		HiddenRAM_ProgNextPtr=HiddenRAM_Top;	// Hidden RAM Prog next ptr
}
void HiddenRAM_freeMat( int reg ){
	char *ptr = (char *)MatAry[reg].Adrs;
	int	size = MatAry[reg].Maxbyte; 
	if ( (int)ptr < (int)HiddenRAM_Top ) free( ptr );
	else {
		if ( (int)HiddenRAM_MatTopPtr == (int)ptr ) HiddenRAM_MatTopPtr += ( (size+7) & 0xFFFFFFF8 );
	}
}

const char MatAryCheckStr[]="#CBasic163#";

void HiddenRAM_MatAryStore(){	// MatAry ptr -> HiddenRAM
	int *iptr1=(int*)(HIDDENRAM_TOP+12);
	int *iptr2=(int*)(HiddenRAM_End+12);
	if ( ( UseHiddenRAM ) && ( IsHiddenRAM ) ) {
		memcpy( (char *)HIDDENRAM_TOP, MatAryCheckStr, sizeof(MatAryCheckStr) );
		memcpy( HiddenRAM_End,         MatAryCheckStr, sizeof(MatAryCheckStr) );
		memcpy( HiddenRAM_End+16,      PictAry, sizeof(PictAry) );
		iptr1[0]=(int)MatAry;
		iptr2[0]=(int)HiddenRAM_MatTopPtr;
	}
}
int HiddenRAM_MatAryRestore(){	//  HiddenRAM -> MatAry ptr
	char buffer[10];
	int *iptr1=(int*)(HIDDENRAM_TOP+12);
	int *iptr2=(int*)(HiddenRAM_End+12);
	char *tmp;
	tmp=HiddenRAM_End - VRAMSIZE*(20+ExtendPict) - sizeof(matary)*MatAryMax ;
	if ( !(UseHiddenRAM&0xF0) )return 0;	// hidden init
	if ( ( UseHiddenRAM ) && ( IsHiddenRAM ) && ( (char *)iptr1[0]==tmp ) ){
		if ( ( strcmp((char *)HIDDENRAM_TOP, MatAryCheckStr) == 0 ) && ( strcmp(HiddenRAM_End, MatAryCheckStr) == 0 ) ) {
			memcpy( PictAry, HiddenRAM_End+16, sizeof(PictAry) );
			HiddenRAM_MatTopPtr=(char*)iptr2[0];
			MatAry=(matary *)tmp;
			return 1;	// ok
		}
	}
	return 0;
}
void HiddenRAM_MatAryInit(){	// HiddenRAM Initialize
	char buffer[10];
	int *iptr1=(int*)(HIDDENRAM_TOP+12);
	int *iptr2=(int*)(HiddenRAM_End+12);
	MatAryMax=MATARY_MAX +ExtendList*52;
	Mattmpreg=MatAryMax-1;
	ExtListMax=MatAryMax-33;
	EditMaxfree = EDITMAXFREE;
	EditMaxProg = EDITMAXPROG;
	NewMax      = NEWMAX;
	ClipMax     = CLIPMAX;
	if ( ( UseHiddenRAM ) && ( IsHiddenRAM ) ) {		// hidden RAM init
		EditMaxfree = EDITMAXFREE2;
		EditMaxProg = EDITMAXPROG2;
		NewMax      = NEWMAX2;
		ClipMax     = CLIPMAX2;
		OplistRecentFreq=(toplistrecentfreq *)(HIDDENRAM_TOP+16);
		OplistRecent    =(short *)(HIDDENRAM_TOP+16+128);
		if ( HiddenRAM_MatAryRestore() ) return ;			// hidden RAM ready
		HiddenRAM_MatTopPtr = HiddenRAM_End - VRAMSIZE*(20+ExtendPict) - sizeof(matary)*MatAryMax ;
		MatAry = (matary *)HiddenRAM_MatTopPtr;
		HiddenRAM_MatAryStore();
		InitOpcodeRecent();
	} else {		// use heap RAM
		MatAry = ( matary *)malloc( sizeof(matary)*MatAryMax );
		OplistRecentFreq=(toplistrecentfreq *)OplistRecentFreqMem;
		OplistRecent    =(short *)OplistRecentMem;
		InitOpcodeRecent();
	}
	memset( MatAry, 0, sizeof(matary)*MatAryMax );
}

